/*
 * @Description: Splash page
 * @Version: 1.0
 * @Autor: Henry Hao(HaoYu)
 * @Date: 2019-11-6 15:28:48
 * @LastEditors: Henry Hao(HaoYu)
 * @LastEditTime: 2019-11-6 15:48:49
 */

import 'dart:async';

import 'package:flutter/widgets.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:shareinstall_flutter/shareinstall_flutter.dart';


class SplashPage extends StatelessWidget {


  @override
  Widget build(BuildContext context) {

    print("-------------splashpage  build ---------------------------");
    return MaterialApp(
      home: _SplashPage(),
      debugShowCheckedModeBanner: false,
    );
  }

}

class _SplashPage extends StatefulWidget {


  @override
  State<StatefulWidget> createState() {
    return _SplashPageState();
  }
}

class _SplashPageState extends State<_SplashPage> {
  Timer timer;
  var count = 3;



  @override
    void initState() {

    print("-------------_SplashPageState  initState ---------------------------");

    super.initState();
    countDown();
  }


  @override
  void dispose() {
    print("-------------_SplashPageState  Dispose ---------------------------");
    super.dispose();

  }

  @override
  Widget build(BuildContext context) {
    print(
        "----------------------_SplashPageState build begin---------------------------");

    return new WillPopScope(

        onWillPop: () async {

          ShareinstallFlutter.clearAppGetInfoListener();
         await SystemChannels.platform.invokeMethod('SystemNavigator.pop');


          return false;
        },
        child: new Stack(children: <Widget>[
          new Image.asset(
            "assets/images/splash/splash.jpg",
            width: double.infinity,
            height: double.infinity,
            fit: BoxFit.cover,
          ),
          new Positioned(
            top: 40.0,
            right: 10.0,
            child: new FlatButton(
              child: new Text(
                 count.toString() +' Skip',
                style: new TextStyle(color: Colors.white),
              ),
              color: Color.fromARGB(55, 0, 0, 0),
              onPressed: () {
                timer.cancel();
                goHomePage();
              },
            ),
          ),
        ])


    ); //willpopScope
  }


  //倒计时
  void countDown() {

    timer = new Timer(new Duration(seconds: 1), () {
      // 只在倒计时结束时回调
      if (count != 1) {
        setState(() {
          count = count - 1;
          countDown();
        });
      } else {
        timer.cancel();
        goHomePage();
      }
    });
  }

//  jump to home page
  void goHomePage() {

    /*
    Navigator.of(context).pushAndRemoveUntil(
        //jump and destroy current page
        new MaterialPageRoute(builder: (context) => new MeWebview()),
            (route) => route == null);
*/


  }
}